; msodperces idzt

	list p=12f1501	
	list r=dec
	#include <p12f1501.inc>
	#include <prlx.inc>
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_ON & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _CLKOUTEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _STVREN_OFF & _BORV_HI & _LVP_OFF

scale	equ	249
t2ini	equ	9

#define keyin	porta,3	; gomb bemenet (kls lehz ellenllssal)
#define serout	lata,2	; bitkimenet
#define	regck	lata,1	; rvnyest kimenet (a felfut le hatsos)
#define serck	lata,0	; bit rajel kimenet (a felfut le hatsos)

	cblock	0x70
	flags	; vegyes jelzbitek
	count   ; lptetsszmll (init 16)
	mux     ; multiplexer szmllja
	d3      ; digit3 (bal szls, a krtyn D1-nek jellve)
	d2      ; digit2 (a krtyn D2-nek jellve)
	d1      ; digit1 (a krtyn D3-nak jellve)
	d0      ; digit0 (jobb szls, a krtyn D4-nek jellve)
	d2a	; ktszeres frekvencij d2 (a 2 Hz miatt)
	ki1     ; elsknt kivitt (fels) bjt, U2-be rkezik
	ki0     ; msodikknt kivitt (als) bjt, U1-be rkezik
	kb1     ; ide olvassa a gombokat,
	kb0     ; s innen dolgozza fel
	fmpsz	; flmsodpercre oszt szmll
	endc
#define stst    kb0,3	; start-stop (bal fels), stopban bellts
#define clr0    kb0,2	; aktv/passzv (bal/jobb) mez kivlasztsa
#define inc1    kb0,1	; tzeseket inkrementl (jobb fels)
#define inc0    kb0,0	; egyeseket inkrementl (jobb als)
#define kin     kb1,0	; ide szedi be egyesvel a gombokat
#define dp	ki0,4	; tizedespont bit

#define szamol	flags,0	; fut a szmll
#define	van	flags,1	; van feldolgozand bemenet
#define	ures	flags,2	; volt eltte nyoms nlkli llapot
#define	bumm	flags,3	; idzt kimenet httrbitje
#define	tized	flags,4	; itt trolom a jumper opcit 
; Program kezdete	
	org	0
	clrf	intcon
	banksel	0
	clrf	pclath
	goto	start

; Megszakts 
	org	4
	bcf	pir1,tmr2if
	banksel	lata
	bcf	regck	; tr ra le
	nop
	bsf	regck	; tr ra fel 
	banksel	porta
	clrwdt
	rlf	kb1,f	; keyboard input regiszterben helycsinls
	nop
	nop
	nop
	sb	keyin
	bcf	kin
	snb	keyin
	bsf	kin	; majd a bejv bit elhelyezse
	incf	mux,f	; a kvetkezre mutat (balrl jobbra halad)
	movf	mux,w
	andlw	3
	jnz	itsk0
; amikor mux=0, elmenti a gombokat, ha nincs elz feldolgozatlan adat
	jb	van,itsk0	; amg van, nincs ments
	movf	kb1,w
	movwf	kb0
	clrf	kb1
	bsf	van	; s jelzi, hogy mr van mit feldolgozni,
; legyrtja s kiviszi a kvetkez digitet, csak nem rvnyesti:
itsk0			
	movf	mux,w
	andlw	3
	addlw	d3	; d3...d0 a RAM sorrend!
	movwf	fsr0l
	movf	indf0,w
	andlw	15
	addlw	segtbl
	callw		; bejn a szegmenskp, ketttrs indul
	movwf	ki1	; fels sz mr csak maszkra vr
	andlw	0f0h
	movwf	ki0	; als sz fels 4 bitje majdnem ksz
	movlw	0fh	; maszkolom is a felst, mert hasznlni akarom
	andwf	ki1,f	; a fels 4 bitje 0, megltjuk, gy marad-e
	movf	mux,w
	andlw	3
	addlw	digtbl
	callw
	addwf	ki0,f	; als szba bekltzik a mux
;a jumper opcinak kell a tizedespont az 1. s 3. szmjegy mgtt:
	bsf	dp
	snb	tized
	snb	mux,0	; (mux=0 ell, d3-mal kezdi a kirst!)
	bcf	dp
; most jnnek a kimenetnek hasznlt bitek (eltrlve)
	snb	bumm	; bumm = lejrt
	bsf	ki1,4	; idzt kimenet
	snb	szamol	; szamol = fut
	bsf	ki1,5	; kapcsolra kimenet
	call	regout	; kivitel, rvnyests nlkl
	jnb	szamol,vissza	; ll a szmll: megszakts vge
; A szmll bizony messze nem binris: 
	decfsz	fmpsz,f
	goto	vissza
	movlw	250
	snb	tized
	movlw	25
	movwf	fmpsz
	incf	d2a,f
	clc
	rrf	d2a,w
	jc	vissza
	movwf	d2
	cjbl	d2a,20,ctsk1
	clrf	d2
	clrf	d2a
	incf	d3,f
	csbl	d3,10
	clrf	d3
ctsk1			; egyezs ellenrzse szmjegyenknt
	bcf	szamol
	cse	d2,d0
	bsf	szamol
	cse	d3,d1
	bsf	szamol
	sb	szamol
	bsf	bumm
vissza			; automatikus visszallts a megszakts vgn	
	retfie
	
segtbl			; szegmenstblzat a kijelzhz  
        dt    0cfh,6,0adh,2fh,66h,6bh,0ebh,0eh,0efh, 6fh,1,2,4,8,16,32
digtbl			; szmjegykijell tblzat a kijelzhz
        dt    1,2,4,8

; Fprogram
start
	banksel	lata
	clrf	lata		; a port belltst j elre elintzni
	banksel	ansela		; 
	clrf	ansela		; nincs analg lb
	banksel	wdtcon
	movlw	0ah
	movwf	wdtcon
	banksel	trisa		; 
	bcf	option_reg,t0cs	; biztos, ami biztos
	movlw	8		
	movwf	trisa		; csak gp3 bemenet
	clrf	pie1		; arra is inicializldik mindhrom
	clrf	pie2
	clrf	pie3
	bsf	pie1,tmr2ie	; erre a megszaktsra szksg lesz
	movlw	68h
	movwf	osccon		; 4 MHz
	banksel	0		; bank0 jn
	clrf	flags		; vltozk elksztse
	clrf	ki0
	movlw	80h
	movwf	ki1
	call	regout		; kimegy az 1 a legfels biten
	banksel	lata
	bcf	regck	; tr ra le
	nop
	bsf	regck	; tr ra fel, most rdik t 
	banksel	porta
	nop
	nop
	nop
	sb	keyin	; kis ksleltetssel az opcibit beolvashat 
	bcf	tized
	snb	keyin
	bsf	tized	; a "tized" bitvltozba
	movlw	250
	snb	tized
	movlw	25
	movwf	fmpsz	; s az eloszt ennek megfelel rtket kap
	clrf	ki1
	clrf	ki0
	clrf	kb1
	clrf	kb0
	clrf	d0
	clrf	d1
	clrf	d2
	clrf	d2a
	clrf	d3
	clrf	fsr0h
	clrf	pclath	
	call	timini		; timer2 indul, t2 megsz. engedlyezve
main
	jnb	van,main
	movf	kb0,w
	andlw	15
	snz
	bsf	ures
	jnb	ures,msk2
; ide csak nyoms nlkli elz beolvass utn lehet eljutni
	jb	stst,indall
	jb	clr0,torol
	jb	inc1,novel
	jnb	inc0, msk2+1	; egyik sem?!
; az elnevezsekkel ellenttben nincs cskkents: a cskkent gomb az 
; als, a nvel gomb a fels digitet nveli. Ez itt a cskkent.
	bcf	inc0	
	incf	d0,f
	csbl	d0,10
	clrf	d0
msk2
	bcf	ures
	bcf	van
	goto	main
torol	
	bcf	szamol
	bcf	bumm
	bcf	intcon,gie
	clrf	d3
	clrf	d2
	clrf	d2a
	bcf	clr0
	movlw	250
	snb	tized
	movlw	25
	movwf	fmpsz
	bsf	intcon,gie
	goto	msk2
novel
	bcf	inc1
	incf	d1,f
	csbl	d1,10
	clrf	d1	
	goto	msk2
indall		; megfordtja a beall bit llapott, a szmlls lell
	bcf	stst
	snb	bumm
	goto	torol
	movlw	1
	xorwf	flags,f
	bcf	bumm
	goto	msk2
	
timini
	movlw	scale
	movwf	pr2
	bcf	pir1,tmr2if
	movlw	t2ini
	movwf	t2con
	bsf	t2con,tmr2on
	bsf	intcon,peie
	bsf	intcon,gie
	return
	
regout
	movlw	16
	movwf	count	; lpsszmll
	banksel	lata
ro_lp
	rlf	ki0,f
	rlf	ki1,f
	sc
	bcf	serout
	snc
	bsf	serout
	nop
	bsf	serck
	nop
	bcf	serck
	decfsz	count,f
	goto	ro_lp
	banksel	0
	return	
	end
