; j1501.asm: 99 perc/99 perc idzt. Egyik sem tartalmazza a msikat.
; Egy nulla az adott flperidus kihagyst, kt nulla a kikapcsolt
; llapotot jelenti. Az Urbn-fle ngygombos panellel mkdik. 
; A bal szm (d3,d2) a bekapcsolt id, a jobb (d1,d0) a kikapcsolt. 
; A gombok: 
; bal fels: bellts/ zem (d3 temben aktv, ez a nulls kimen bit)
; bal als: melyiket lltom? (d2 temben lehet beolvasni)
; jobb fels: tzesek fel (d1-ben. ki0.2=1)
; jobb als: egyesek fel (d0-ban, ki0.3=1)

	list p=12f1501	; ettl j1501 a fjl
	list r=dec
	#include <p12f1501.inc>
	#include <prlx.inc>
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_ON & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _CLKOUTEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _STVREN_OFF & _BORV_HI & _LVP_OFF

scale	equ	249
t2ini	equ	9

#define relout	lata,5
#define keyin	porta,3
#define serout	lata,2
#define	regck	lata,1
#define serck	lata,0

; A program vltozi: 
	cblock	0x20
	precth	; eloszt perchez, magas
	prectl	; eloszt perchez, alacsony
	counth	; szmll fels
	countl	; szmll als
	onth	; bekapcsolt id magas
	ontl	; bekapcsolt id alacsony
	offth	; kikapcsolt id magas
	offtl	; kikapcsolt id alacsony
	count3	; a fggetlen 1 perc szmllja
	count5	; 5 msodperces szmll
	zflag	; nem nulla aktv ill. passzv id
	endc		
	cblock	0x70
	wtemp	; w ment regisztere
	stemp	; status ment regisztere
	ftemp	; fsr0l ment regisztere
	flags	; vegyes jelzbitek
	count   ; lptetsszmll (init 16)
	mux     ; multiplexer szmllja
	d3      ; digit3 (bal szls)
	d2      ; digit2
	d1      ; digit1
	d0      ; digit0 (jobb szls)
	ki1     ; elsknt kivitt bjt
	ki0     ; msodikknt kivitt bjt
	kb1     ; ide olvassa a gombokat,
	kb0     ; s innen dolgozza fel
	ccount	; flash karakterszmll
	endc
#define stst    kb0,3	; start-stop (bal fels), stopban bellts
#define fsel    kb0,2	; aktv/passzv (bal/jobb) mez kivlasztsa
#define inc1    kb0,1	; tzeseket inkrementl (jobb fels)
#define inc0    kb0,0	; egyeseket inkrementl (jobb als)
#define kin     kb1,0	; ide szedi be egyesvel a gombokat
#define beall   flags,0	; nem belltssal bred, hanem szmolssal
#define van     flags,1	; kbd kezelshez (valami nyomva van)
#define ures    flags,2	; kbd kezelshez (kzben volt sznet)
#define feny	flags,3	; az 1 perces idzt szinkronja
#define aktiv	flags,4	; aktv id mez van kijellve
#define light	flags,5	; az 5 msodperces idzt vezrlbitje
#define	ton	flags,6	; van aktv s passzv id is, szmoljon
#define	loff	flags,7	; minden szegmens stt legyen
#define anem0	zflag,1	; van aktv szakasz
#define	pnem0	zflag,0	; van passzv szakasz

; Program kezdete	
	org	0
	clrf	intcon
	banksel	0
	clrf	pclath
	goto	start

; Megszakts 
	org	4
	bcf	pir1,tmr2if
	banksel	lata
	bcf	regck	; tr ra le
	nop
	bsf	regck	; tr ra fel 
	banksel	porta
	clrwdt
	rlf	kb1,f	; keyboard input regiszterben helycsinls
	nop
	nop
	nop
	sb	keyin
	bcf	kin
	snb	keyin
	bsf	kin
	incf	mux,f
	movf	mux,w
	andlw	3
	jnz	itsk0
; amikor mux=0, elmenti a gombokat, ha nincs elz feldolgozatlan adat
	jb	van,itsk0
	movf	kb1,w
	movwf	kb0
	clrf	kb1
	bsf	van	; s jelzi, hogy van mit feldolgozni,
; kiviszi a kvetkez digitet, csak nem rja t:
itsk0			
	movf	mux,w
	andlw	3
	addlw	d3
	movwf	fsr0l
	movf	indf0,w
	andlw	15
	addlw	segtbl
	callw
	movwf	ki1	; fels sz elkszlt
	andlw	0f0h
	movwf	ki0	; als sz fels 4 bitje majdnem ksz
	snb	loff	
	clrf	ki1	; ki1 stt marad,ha loff=1
	snb	loff
	clrf	ki0	; ilyenkor ki0 is stt marad,
	movf	mux,w
	andlw	3
	addlw	digtbl
	callw
	addwf	ki0,f	; de a mux rsze termszetesen l.
	sb	beall	; Ha beall=1 (bellts zemmdban van)
	snb	light	; vagy light=1 (ez az a fl msodperc)
	call	setdp	; akkor kirakja a tizedespontot.
; Utna mr kisprhet az j adat
	movlw	16
	movwf	count	; lpsszmll
	banksel	lata
itlp0
	rlf	ki0,f
	rlf	ki1,f
	sc
	bcf	serout
	snc
	bsf	serout
	nop
	bsf	serck
	nop
	bcf	serck
	decfsz	count,f
	goto	itlp0
	banksel	0	
	jb	beall,vissza	; bellts alatt llnak a szmllk
; A szmll els elosztja, kimenete a 0,5 s-os alapjel. 
	decfsz	precth,f
	goto	vissza
	movlw	250
	movwf	precth
; jn egy egyperces fggetlen szmll, az 1 percet hvskor kell 
; belltani, a vgn kikapcsolja a fnyt:
	jnb	feny,sk1p
	decfsz	count3,f
	goto	sk1p
	bcf	feny	; lelvi magt
	bsf	loff	; s a szegmenseket
sk1p
; ide jn a flmsodperces tennival, a tizedespont eltntetse
	bcf	light	; ez csak a futs kzbeni tizedespontra hat
; ez az 5 msodperces szmll nincs az osztlncban, viszont a fl
; msodperchez van szinkronizlva.
	decfsz	count5,f
	goto	itsk2
	movlw	10
	movwf	count5
; t msodpercenknt bekapcsolja a tizedespontot,hogy a fl msodperces
; majd kikapcsolja.
	bsf	light		
itsk2
	sb	ton	; ha valamelyik programozott id 0, ton=0
	goto	vissza	; ha nincs id, itt a megszakts vge
	decfsz	prectl,f
	goto	vissza	; nem telt le a perc
	movlw	120
	movwf	prectl
; counth s countl kt decimlis digites szmll. Minden j percrtket
; t kell rni az aktulis mezbe. Lp, ha beall = 0, ton = 1 s letelt 
; a perc.
	decf	countl,f
	movf	countl,w
	iorwf	counth,w
	snz
	goto	itsk3	; ez trtnjen, ha lejrt
	incf	countl,w
	jnz	itsk4
	movlw	9
	movwf	countl
	decf	counth,f
	incf	counth,w
	jnz	itsk4
	movlw	9	;soha nem szabad megtrtnnie!
	movwf	counth
itsk4			; trs kijelz mezbe (percenknt)
	movf	counth,w
	sb	aktiv
	movwf	d1
	snb	aktiv
	movwf	d3
	movf	countl,w
	sb	aktiv
	movwf	d0
	snb	aktiv
	movwf	d2
	goto	vissza
itsk3			; lejrt az egyik fajta id
	sb	aktiv	
	goto	itsk5
	movf	onth,w	; aktv id lejrt, kezdrtk helyrelltsa
	movwf	d3
	movf	ontl,w
	movwf	d2
	movf	offth,w	; az aktv id jrt le: passzvat kell tlteni
	movwf	d1
	movwf	counth
	movf	offtl,w
	movwf	d0
	movwf	countl
itsk6	
	bcf	aktiv
	banksel	lata
	bcf	relout
	banksel	porta
	goto	vissza
itsk5			; ugyanaz, amikor a passzv jr le
	movf	onth,w
	movwf	d3
	movwf	counth
	movf	ontl,w
	movwf	d2
	movwf	countl
	movf	offth,w
	movwf	d1
	movf	offtl,w
	movwf	d0
	bsf	aktiv
	banksel	lata
	bsf	relout
	banksel	porta
vissza			; visszallts a megszakts vgn	
	retfie
	
segtbl			; szegmenstblzat a kijelzhz  
        dt    0cfh,6,0adh,2fh,66h,6bh,0ebh,0eh,0efh, 6fh,1,2,4,8,16,32
digtbl			; szmjegykijell tblzat a kijelzhz
        dt    1,2,4,8
setact			; szubrutin a passzv id=0 esetre
	banksel	lata
	bsf	relout
	banksel	porta
	bcf	ton
	bsf	aktiv
	return
	
; Fprogram
start
	banksel	lata
	clrf	lata		; a port belltst j elre elintzni
	banksel	ansela		; 
	clrf	ansela		; nincs analg lb
	banksel	wdtcon
	movlw	0ah
	movwf	wdtcon
	banksel	trisa		; 
	bcf	option_reg,t0cs	; biztos, ami biztos
	movlw	8		
	movwf	trisa		; csak gp3 bemenet
	clrf	pie1		; arra is inicializldik mindhrom
	clrf	pie2
	clrf	pie3
	bsf	pie1,tmr2ie	; erre a megszaktsra szksg lesz
	movlw	68h
	movwf	osccon		; 4 MHz
	banksel	0		; bank0 jn
	clrf	flags		; vltozk elksztse
	clrf	ki0
	clrf	ki1
	clrf	kb1
	clrf	kb0
	clrf	fsr0h
	clrf	pclath	
	movlw	250
	movwf	precth
	movlw	120
	movwf	prectl		; perc eloszt 1 percre elksztve
	movlw	10
	movwf	count5
	call	gettime		; a ngy mentett bjt visszatltse
	banksel	0
	call	restore		; s trsa d3...d0-ba nmi sallanggal
	call	ldpas		; passzv szakasz tltse
	movlw	120		; 120 darab flmsodperc, azaz
	movwf	count3
	bsf	feny		; 1 perc mlva sttts
	bsf	ton		; zflag felhasznlsa eltt kell
	call	timini		; timer2 indul, t2 megsz. engedlyezve
	call	zchk
main
	jnb	van,main
	movf	kb0,w
	andlw	15
	snz
	bsf	ures
	jnb	ures,msk2
; ide csak nyoms nlkli elz beolvass utn lehet eljutni
	jb	stst,indall
	jnb	beall,msk1
; ha nem bellts mdban van, ezeket ki kell hagynia!
	jb	fsel,valaszt	; ez a mit lltok!
	jb	inc1,novel
	jnb	inc0, msk2+1	; egyik sem?!
; az elnevezsekkel ellenttben nincs cskkents: a cskkent gomb az 
; als, a nvel gomb a fels digitet nveli. Ez itt a cskkent.
	bcf	inc0	
	movlw	d0
	snb	aktiv
	movlw	d2
	movwf	fsr0l
	incf	indf0,f
	cjbl	indf0,10,msk2
	clrf	indf0
msk2
	bcf	ures
	bcf	van
	goto	main
msk3
	clrf	kb0
	bcf	van
	goto	main
msk1
	sb	inc1
	goto	msk3
	bcf	loff	; A gomb kapcsolja, utna 1 perc!
	bsf	feny
	bcf	inc1
	goto	msk2
novel
	bcf	inc1	
	movlw	d1
	snb	aktiv
	movlw	d3
	movwf	fsr0l
	incf	indf0,f
	cjbl	indf0,10,msk2
	clrf	indf0
	goto	msk2
indall		; megfordtja a beall bit llapott, a szmlls lell
	movlw	1
	xorwf	flags,f
	bcf	stst
	sb	beall
	goto	restart
	call	restore
	banksel	lata
	bcf	relout
	banksel	porta
	goto	msk2
restart
	movf	d3,w
	movwf	onth
	movf	d2,w
	movwf	ontl
	movf	d1,w
	movwf	offth
	movf	d0,w
	movwf	offtl
	bcf	intcon,peie
	call	clrflash
	call	savtime	; bellts utn menteni!
	banksel	0
; idig tartana az ellenrzs
; ez itt a kezd perc belltsa
	movlw	120
	movwf	count3
	call	ldpas	; ez a passzv adatok betltse
	bsf	feny
	call	zchk
	bcf	pir1,tmr2if
	bsf	intcon,peie
	goto	msk2
valaszt		; kivlasztja a mezt
; csak szamol=0 mellett fut, s ha igaz nincs ms teendje.
	movlw	10h
	xorwf	flags,f
	bcf	fsel
	goto	msk2
	
timini
	movlw	scale
	movwf	pr2
	bcf	pir1,tmr2if
	movlw	t2ini
	movwf	t2con
	bsf	t2con,tmr2on
	bsf	intcon,peie
	bsf	intcon,gie
	return
	
setdp			; kirakja a tizedespontot
	jb	aktiv,sdpsk
	snb	ki0,3
	bsf	ki0,4
	return
sdpsk
	snb	ki0,1
	bsf	ki0,4
	return
	
gettime		; helyrellts HE flash-bl, 4 bjt
	movlw	4
	movwf	ccount
	movlw	onth
	movwf	fsr0l
	BANKSEL	PMADRL
	MOVLW	80H
	MOVWF	PMADRL
	MOVLW	3
	MOVWF	PMADRH
gtlp
	BCF	PMCON1,CFGS
	BSF	PMCON1,RD
	NOP
	NOP
	MOVF	PMDATL,W
	MOVWI	fsr0++
	INCF	PMADRL,F
	decfsz	ccount,f
	goto	gtlp
	banksel	0
	return
	
savtime		; ments HE flash-be,4 bjt
	movlw	3	; 3 bjt elszr csak sorpufferbe
	movwf	ccount
	movlw	onth
	movwf	fsr0l
	BANKSEL	PMADRL
	MOVLW	80h
	MOVWF	PMADRL
	MOVLW	3
	MOVWF	PMADRH
	BSF PMCON1,LWLO ; Csak a httrbjtokat
stlp
	MOVIW	FSR0++
	MOVWF	PMDATL
	CALL	FWRI
	BCF	PMCON1,WREN		
	incf	PMADRL,f
	decfsz	ccount,f
	goto	stlp		; 
	BCF	PMCON1,LWLO	; a negyedik mr igazi rssal
	MOVIW	FSR0++
	MOVWF	PMDATL
	CALL	FWRI
	BCF	PMCON1,WREN		
	banksel	0
	bsf	intcon, gie
	return

FWRI				; flash r szubrutin 1 bjtra
	BCF	PMCON1,CFGS
	BSF	PMCON1,WREN
	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$-2
	MOVLW	55H
	MOVWF	PMCON2
	MOVLW	0AAH
	MOVWF	PMCON2
	BSF	PMCON1,WR
VIZSG
	BTFSS	PMCON1,WR
	RETURN
	GOTO	VIZSG
	
CLRFLASH
	BANKSEL PMADRL
	MOVLW 80h ; mentsi cm als bjtja
	MOVWF PMADRL
	MOVLW 3 ; mentsi cm fels bjtja
	MOVWF PMADRH
	CALL FWRI
	BCF PMCON1,WREN ; Tovbbi rs tiltsa
	BSF INTCON,GIE ; 
	RETURN

restore			;lland fnyt kapcsol, s a fixeket rja ki
	bcf	feny
	bcf	loff
	movf	onth,w
	movwf	d3
	movf	ontl,w
	movwf	d2
	movf	offth,w
	movwf	d1
	movf	offtl,w
	movwf	d0
	return		; cnth:cntl-t is belltja
	
zchk			; programozott idk nullvizsglata
	clrf	zflag	; mintha mindkt id 0 lenne
	movf	onth,w
	iorwf	ontl,w
	sz
	bsf	anem0	; az aktv id nem nulla
	movf	offth,w
	iorwf	offtl,w
	sz
	bsf	pnem0	; a passzv id nem nulla
	bsf	ton	; zflag felhasznlsa eltt kell
	movf	zflag,f
	snz
	bcf	ton	; ez a mindkett nulla esete
	sb	anem0
	bcf	ton	; ez az aktv id nulla	
	sb	pnem0
	call	setact	; ez az aktv nem 0, de a passzv igen
	return		; ez az egyik sem nulla
	
ldpas			; passzv paramterek tltse
	movf	offth,w
	movwf	counth
	movf	offtl,w
	movwf	countl
	bcf	aktiv
	banksel	lata
	bcf	relout
	banksel	porta
	return
	
	org	380h
	dt	0,1,0,1		
    end
